create_clock -name fast_clk_p -period 2.000 [get_ports {dco_u_p}]
create_clock -name fast_clk_n -period 2.000 [get_ports {dco_u_n}]

#derive_pll_clocks

create_clock -name slow_clk -period 20.000 [get_ports {SYSCLK}]
#derive_pll_clocks

create_generated_clock -name pll4clk0 -source [get_pins {altpll_source4|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 4 -multiply_by 1 [get_pins {altpll_source4|altpll_component|auto_generated|pll1|clk[0]}]
create_generated_clock -name pll4clk1 -source [get_pins {altpll_source4|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 4 -multiply_by 1 [get_pins {altpll_source4|altpll_component|auto_generated|pll1|clk[1]}]
create_generated_clock -name pll4clk2 -source [get_pins {altpll_source4|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 4 -multiply_by 1 [get_pins {altpll_source4|altpll_component|auto_generated|pll1|clk[2]}]
create_generated_clock -name pll4clk3 -source [get_pins {altpll_source4|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 4 -multiply_by 1 [get_pins {altpll_source4|altpll_component|auto_generated|pll1|clk[3]}]
create_generated_clock -name pll4clk4 -source [get_pins {altpll_source4|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 4 -multiply_by 1 [get_pins {altpll_source4|altpll_component|auto_generated|pll1|clk[4]}]

create_generated_clock -name pll2clk0 -source [get_pins {altpll_source2|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 200 [get_pins {altpll_source2|altpll_component|auto_generated|pll1|clk[0]}]
#create_generated_clock -name pll2clk1 -source [get_pins {altpll_source2|altpll_component|auto_generated|pll1|inclk[0]}] -divide_by 10 [get_pins {altpll_source2|altpll_component|auto_generated|pll1|clk[1]}]

#**************************************************************
# JTAG Clock Constraints
#**************************************************************

#constrain the TCK port
#create_clock -name tck -period "10MHz" [get_ports altera_reserved_tck]
create_clock -name {altera_reserved_tck} -period 100.000 -waveform { 0.000 50.000 } [get_ports {altera_reserved_tck}]

derive_clock_uncertainty

#set_false_path -from [get_ports {MEMSIZE_JMP*}]

#set_false_path -from [get_ports {CHSEL_JMP*}]

set_false_path -from [get_ports {dco_d_p}]

#set_false_path -from [get_ports {MPI2_RESET}]
#set_false_path -from [get_ports {capture_start}] 
#set_false_path -from [get_ports {data_collection}]

#set_false_path -from {altbram_ctrl:altbram_ctrl|CAPTURE_DONE} -to [get_ports {CAPTURE_DONE}]
#set_false_path -from {pll4_locked_reg} -to [get_ports {TILE0_PLLLKDET_OUT}]
#set_false_path -from {rx_locked_reg} -to [get_ports {TILE0_PLLLKDET_OUT}]
set_false_path -from {altpll_source4|altpll_component|auto_generated|pll1|clk[1]} -to [get_ports {cllclk}]

set_false_path -from {rx_reset*}

set_input_delay -clock { pll2clk0 } -max 6.5 [get_ports {lcd_data[7]}]
set_input_delay -clock { pll2clk0 } -min 3.5 [get_ports {lcd_data[7]}]

set_input_delay -clock { pll4clk4 } -max 0.5 [get_ports {out*a_p}]
set_input_delay -clock { pll4clk4 } -min 3.5 [get_ports {out*a_p}]

set_input_delay -clock { pll4clk4 } -max 0.5 [get_ports {out*b_p}]
set_input_delay -clock { pll4clk4 } -min 3.5 [get_ports {out*b_p}]

set_input_delay -clock { pll4clk4 } -max 0.5 [get_ports {fr_d_p}]
set_input_delay -clock { pll4clk4 } -min 3.5 [get_ports {fr_d_p}]

set_input_delay -clock { pll4clk4 } -max 0.5 [get_ports {fr_u_p}]
set_input_delay -clock { pll4clk4 } -min 3.5 [get_ports {fr_u_p}]

set_output_delay -clock { pll4clk3 } -max 0.8 [get_ports {clldata*}]
set_output_delay -clock { pll4clk3 } -min 0.1 [get_ports {clldata*}]

set_output_delay -clock { pll4clk3 } -max 0.8 [get_ports {cllctrl}]
set_output_delay -clock { pll4clk3 } -min 0.1 [get_ports {cllctrl}]


set_output_delay -clock { pll2clk0 } -max 3.5 [get_ports {lcd_data*}]
set_output_delay -clock { pll2clk0 } -min 0.1 [get_ports {lcd_data*}]

set_output_delay -clock { pll2clk0 } -max 3.5 [get_ports {lcd_csn}]
set_output_delay -clock { pll2clk0 } -min 0.1 [get_ports {lcd_csn}]

set_output_delay -clock { pll2clk0 } -max 3.5 [get_ports {lcd_d_cn}]
set_output_delay -clock { pll2clk0 } -min 0.1 [get_ports {lcd_d_cn}]

set_output_delay -clock { pll2clk0 } -max 3.5 [get_ports {lcd_wen}]
set_output_delay -clock { pll2clk0 } -min 0.1 [get_ports {lcd_wen}]

#**************************************************************
# JTAG Signal Constraints
#**************************************************************

#cut all paths to and from tck
#set_clock_groups -exclusive -group [get_clocks {altera_reserved_tck}]

#constrain the TDI port
set_input_delay -clock {altera_reserved_tck} 20 [get_ports altera_reserved_tdi]

#constrain the TMS port
set_input_delay -clock {altera_reserved_tck} 20 [get_ports altera_reserved_tms]

#constrain the TDO port
set_output_delay -clock {altera_reserved_tck} 20 [get_ports altera_reserved_tdo]




