  // LINEAR TECHNOLOGY CORPORATION CONFIDENTIAL
  //
  // $Header$ 
  //
  // FUNCTIONAL DESCRIPTION - 
  // RTL For LTC9011 logic, 
  //  
  
  // UPDATE HISTORY
  //   Author - Gary Yu
  //            
  //   $Log$

//************************************************************************************ 
`timescale 1ns / 1ps

module logic9011 #
(
      parameter REFCLK_PERIOD              =   10.000000 // simulation setting for MGT smartmodel
)
(

dco_u_p,
dco_u_n,

fr_u_p,
fr_u_n,

out0a_p,
out0a_n,

out0b_p,
out0b_n,

out1a_p,
out1a_n,

out1b_p,
out1b_n,

out2a_p,
out2a_n,

out2b_p,
out2b_n,

out3a_p,
out3a_n,

out3b_p,
out3b_n,



dco_d_p,
dco_d_n,

fr_d_p,
fr_d_n,

out4a_p,
out4a_n,

out4b_p,
out4b_n,

out5a_p,
out5a_n,

out5b_p,
out5b_n,

out6a_p,
out6a_n,

out6b_p,
out6b_n,

out7a_p,
out7a_n,

out7b_p,
out7b_n,

shdn,
mode 
  );
 

output dco_u_p;
output dco_u_n;

output fr_u_p;
output fr_u_n;

output out0a_p;
output out0a_n;

output out0b_p;
output out0b_n;

output out1a_p;
output out1a_n;

output out1b_p;
output out1b_n;

output out2a_p;
output out2a_n;

output out2b_p;
output out2b_n;

output out3a_p;
output out3a_n;

output out3b_p;
output out3b_n;



output dco_d_p;
output dco_d_n;

output fr_d_p;
output fr_d_n;

output out4a_p;
output out4a_n;

output out4b_p;
output out4b_n;

output out5a_p;
output out5a_n;

output out5b_p;
output out5b_n;

output out6a_p;
output out6a_n;

output out6b_p;
output out6b_n;

output out7a_p;
output out7a_n;

output out7b_p;
output out7b_n;


input       shdn;  
input [2:0] mode;    

 

reg        fmc1x1_clk,   fmc6x1_clk,   fmc7x1_clk,   fmc8x1_clk;
reg                      fmc6x2_clk,   fmc7x2_clk,   fmc8x2_clk;



    initial 
    begin
      fmc1x1_clk = 1'b1;
      fmc6x1_clk = 1'b1;
      fmc7x1_clk = 1'b1;
      fmc8x1_clk = 1'b1;
      
      fmc6x2_clk = 1'b1;
      fmc7x2_clk = 1'b1;
      fmc8x2_clk = 1'b1;
    end
            
    always
      #(REFCLK_PERIOD/2) fmc1x1_clk = ~fmc1x1_clk;
    
    always
      #(REFCLK_PERIOD/12) fmc6x1_clk = ~fmc6x1_clk;
    
    always
      #(REFCLK_PERIOD/14) fmc7x1_clk = ~fmc7x1_clk;
      
    always    
      #(REFCLK_PERIOD/16) fmc8x1_clk = ~fmc8x1_clk;
      
    always
      #(REFCLK_PERIOD/6) fmc6x2_clk = ~fmc6x2_clk;
    
    always
      #(REFCLK_PERIOD/7) fmc7x2_clk = ~fmc7x2_clk;
      
    always
      #(REFCLK_PERIOD/8) fmc8x2_clk = ~fmc8x2_clk;  

wire fmc_fr = fmc1x1_clk;
 
reg  fmc7x2_fr;
initial fmc7x2_fr = 1'b1;
always @ (posedge fmc1x1_clk)
  fmc7x2_fr <= ~fmc7x2_fr;  
          
  // ----------------------------------------------------
  // test pattern generator
  // ---------------------------------------------------- 
reg [7:0] test0_lbyte, test0_hbyte;
reg [7:0] test1_lbyte, test1_hbyte;
reg [7:0] test2_lbyte, test2_hbyte;
reg [7:0] test3_lbyte, test3_hbyte;

wire [15:0] test0_pat;
wire [15:0] test1_pat;
wire [15:0] test2_pat;
wire [15:0] test3_pat;

reg [7:0] test4_lbyte, test4_hbyte;
reg [7:0] test5_lbyte, test5_hbyte;
reg [7:0] test6_lbyte, test6_hbyte;
reg [7:0] test7_lbyte, test7_hbyte;

wire [15:0] test4_pat;
wire [15:0] test5_pat;
wire [15:0] test6_pat;
wire [15:0] test7_pat;

integer seed0, seed1, seed2, seed3;
integer seed4, seed5, seed6, seed7;

    initial 
    begin
    
      seed0 = 0;
      seed1 = 1;
      seed2 = 2;
      seed3 = 3;
      seed4 = 4;
      seed5 = 5;
      seed6 = 6;
      seed7 = 7;
     
    end
    
always @ (posedge fmc_fr)
begin
  if (~shdn)
  begin
  
    test0_lbyte = 8'h00;
    test0_hbyte = 8'h00;
    
    test1_lbyte = 8'h00;
    test1_hbyte = 8'h22;

    test2_lbyte = 8'h00;
    test2_hbyte = 8'h44;

    test3_lbyte = 8'h00;
    test3_hbyte = 8'h66;
    
    
    test4_lbyte = 8'h00;
    test4_hbyte = 8'h88;
    
    test5_lbyte = 8'h00;
    test5_hbyte = 8'haa;

    test6_lbyte = 8'h00;
    test6_hbyte = 8'hcc;

    test7_lbyte = 8'h00;
    test7_hbyte = 8'hee;
    
  end
  else
  begin
`ifdef RANDOM_PAT
   
    test0_lbyte <= test0_lbyte + $random(seed0) & 8'hff;
    test0_hbyte <= test0_hbyte - $random(seed0) & 8'hff;
    
    test1_lbyte <= test1_lbyte + $random(seed1) & 8'hff;
    test1_hbyte <= test1_hbyte - $random(seed1) & 8'hff;

    test2_lbyte <= test2_lbyte + $random(seed2) & 8'hff;
    test2_hbyte <= test2_hbyte - $random(seed2) & 8'hff;

    test3_lbyte <= test3_lbyte + $random(seed3) & 8'hff;
    test3_hbyte <= test3_hbyte - $random(seed3) & 8'hff;
    
    
    test4_lbyte <= test4_lbyte + $random(seed4) & 8'hff;
    test4_hbyte <= test4_hbyte - $random(seed4) & 8'hff;
    
    test5_lbyte <= test5_lbyte + $random(seed5) & 8'hff;
    test5_hbyte <= test5_hbyte - $random(seed5) & 8'hff;

    test6_lbyte <= test6_lbyte + $random(seed6) & 8'hff;
    test6_hbyte <= test6_hbyte - $random(seed6) & 8'hff;

    test7_lbyte <= test7_lbyte + $random(seed7) & 8'hff;
    test7_hbyte <= test7_hbyte - $random(seed7) & 8'hff;

`else

    test0_lbyte <= test0_lbyte + 1;
    test0_hbyte <= test0_hbyte - 1;
    
    test1_lbyte <= test1_lbyte + 1;
    test1_hbyte <= test1_hbyte - 1;

    test2_lbyte <= test2_lbyte + 1;
    test2_hbyte <= test2_hbyte - 1;

    test3_lbyte <= test3_lbyte + 1;
    test3_hbyte <= test3_hbyte - 1;
    
    test4_lbyte <= test4_lbyte + 1;
    test4_hbyte <= test4_hbyte - 1;
    
    test5_lbyte <= test5_lbyte + 1;
    test5_hbyte <= test5_hbyte - 1;

    test6_lbyte <= test6_lbyte + 1;
    test6_hbyte <= test6_hbyte - 1;

    test7_lbyte <= test7_lbyte + 1;
    test7_hbyte <= test7_hbyte - 1;

`endif
 
  end  
end


assign test0_pat = ({test0_hbyte, test0_lbyte});  
assign test1_pat = ({test1_hbyte, test1_lbyte});
assign test2_pat = ({test2_hbyte, test2_lbyte});
assign test3_pat = ({test3_hbyte, test3_lbyte});

assign test4_pat = ({test4_hbyte, test4_lbyte});  
assign test5_pat = ({test5_hbyte, test5_lbyte});
assign test6_pat = ({test6_hbyte, test6_lbyte});
assign test7_pat = ({test7_hbyte, test7_lbyte});
 

/*
assign test0_pat = {8'h12, 8'h34};
assign test1_pat = {8'h12, 8'h34};
assign test2_pat = {8'h12, 8'h34};
assign test3_pat = {8'h12, 8'h34};
assign test4_pat = {8'h12, 8'h34};
assign test5_pat = {8'h12, 8'h34};
assign test6_pat = {8'h12, 8'h34};
assign test7_pat = {8'h12, 8'h34};
*/

`ifdef P_N_SDR_8x2
/*
wire [15:0] test0_tpat = {test0_pat[13:0], 2'b0};
wire [15:0] test1_tpat = {test1_pat[13:0], 2'b0};
wire [15:0] test2_tpat = {test2_pat[13:0], 2'b0};
wire [15:0] test3_tpat = {test3_pat[13:0], 2'b0};

wire [15:0] test4_tpat = {test4_pat[13:0], 2'b0};
wire [15:0] test5_tpat = {test5_pat[13:0], 2'b0};
wire [15:0] test6_tpat = {test6_pat[13:0], 2'b0};
wire [15:0] test7_tpat = {test7_pat[13:0], 2'b0};
*/
wire [15:0] test0_tpat = test0_pat[15:0];
wire [15:0] test1_tpat = test1_pat[15:0];
wire [15:0] test2_tpat = test2_pat[15:0];
wire [15:0] test3_tpat = test3_pat[15:0];

wire [15:0] test4_tpat = test4_pat[15:0];
wire [15:0] test5_tpat = test5_pat[15:0];
wire [15:0] test6_tpat = test6_pat[15:0];
wire [15:0] test7_tpat = test7_pat[15:0];


`endif

`ifdef P_N_SDR_7x2 
wire [15:0] test0_tpat = {2'b0, test0_pat[13:0]};
wire [15:0] test1_tpat = {2'b0, test1_pat[13:0]};
wire [15:0] test2_tpat = {2'b0, test2_pat[13:0]};
wire [15:0] test3_tpat = {2'b0, test3_pat[13:0]};
`endif

`ifdef P_N_SDR_6x2 
wire [15:0] test0_tpat = {4'b0, test0_pat[13:2]};
wire [15:0] test1_tpat = {4'b0, test1_pat[13:2]};
wire [15:0] test2_tpat = {4'b0, test2_pat[13:2]};
wire [15:0] test3_tpat = {4'b0, test3_pat[13:2]};
`endif

`ifdef P_N_SDR_8x1 
wire [15:0] test0_tpat = {test0_pat[13:0], 2'b0};
wire [15:0] test1_tpat = {test1_pat[13:0], 2'b0};
wire [15:0] test2_tpat = {test2_pat[13:0], 2'b0};
wire [15:0] test3_tpat = {test3_pat[13:0], 2'b0};
`endif

`ifdef P_N_SDR_7x1 
wire [15:0] test0_tpat = {2'b0, test0_pat[13:0]};
wire [15:0] test1_tpat = {2'b0, test1_pat[13:0]};
wire [15:0] test2_tpat = {2'b0, test2_pat[13:0]};
wire [15:0] test3_tpat = {2'b0, test3_pat[13:0]};
`endif

`ifdef P_N_SDR_6x1
wire [15:0] test0_tpat = {4'b0, test0_pat[13:2]};
wire [15:0] test1_tpat = {4'b0, test1_pat[13:2]};
wire [15:0] test2_tpat = {4'b0, test2_pat[13:2]};
wire [15:0] test3_tpat = {4'b0, test3_pat[13:2]};
`endif

wire out0a;
wire out0b;
wire out1a;
wire out1b;
wire out2a;
wire out2b;
wire out3a;
wire out3b;


core2175_sim core2175_sim_0
(
.test_pat(test0_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out0a),
.outb(out0b)

);


core2175_sim core2175_sim_1
(
.test_pat(test1_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out1a),
.outb(out1b)

);


core2175_sim core2175_sim_2
(
.test_pat(test2_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out2a),
.outb(out2b)

);


core2175_sim core2175_sim_3
(
.test_pat(test3_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out3a),
.outb(out3b)

);



wire out4a;
wire out4b;
wire out5a;
wire out5b;
wire out6a;
wire out6b;
wire out7a;
wire out7b;


core2175_sim core2175_sim_4
(
.test_pat(test4_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out4a),
.outb(out4b)

);


core2175_sim core2175_sim_5
(
.test_pat(test5_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out5a),
.outb(out5b)

);


core2175_sim core2175_sim_6
(
.test_pat(test6_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out6a),
.outb(out6b)

);


core2175_sim core2175_sim_7
(
.test_pat(test7_tpat),

.fmc_fr(fmc_fr),
.fmc6x1_clk(fmc6x1_clk),   
.fmc7x1_clk(fmc7x1_clk),   
.fmc8x1_clk(fmc8x1_clk),

.fmc6x2_clk(fmc6x2_clk),   
.fmc7x2_clk(fmc7x2_clk),   
.fmc8x2_clk(fmc8x2_clk),

.shdn(shdn),
.mode(mode),

.outa(out7a),
.outb(out7b)

);


wire       ref6x1_clk,   ref7x1_clk,   ref8x1_clk;
wire       ref6x2_clk,   ref7x2_clk,   ref8x2_clk;

assign #(REFCLK_PERIOD/24) ref6x1_clk = ~fmc6x1_clk;
assign #(REFCLK_PERIOD/28) ref7x1_clk = ~fmc7x1_clk;
assign #(REFCLK_PERIOD/32) ref8x1_clk = ~fmc8x1_clk;

assign #(REFCLK_PERIOD/12) ref6x2_clk = ~fmc6x2_clk;
assign #(REFCLK_PERIOD/14) ref7x2_clk = ~fmc7x2_clk;
assign #(REFCLK_PERIOD/16) ref8x2_clk = ~fmc8x2_clk;

reg dco;
always @ (mode or 
          shdn or
          ref6x1_clk or
          ref7x1_clk or
          ref8x1_clk or
          ref6x2_clk or
          ref7x2_clk or
          ref8x2_clk)
begin
  if (~shdn)
    dco   <= 1'b0;
  else
  begin
  case (mode)
  3'b000:  dco   <= ref8x2_clk;
  3'b001:  dco   <= ref7x2_clk;
  3'b010:  dco   <= ref6x2_clk;
  3'b011:  dco   <= 1'b0;
  3'b100:  dco   <= 1'b0;
  3'b101:  dco   <= ref7x1_clk;
  3'b110:  dco   <= ref6x1_clk;
  3'b111:  dco   <= ref8x1_clk;
  default: dco   <= 1'b0;
  endcase
  end
end
  
//wire fr;
//assign fr = (shdn != 1'b0) ? ((mode != 3'b001) ? fmc_fr : fmc7x2_fr) : 1'b0;

wire       ref6x1_fr,   ref7x1_fr,   ref8x1_fr;
wire       ref6x2_fr,   ref7x2_fr,   ref8x2_fr;

assign #(REFCLK_PERIOD/12) ref6x1_fr = fmc_fr;
assign #(REFCLK_PERIOD/14) ref7x1_fr = fmc_fr;
assign #(REFCLK_PERIOD/16) ref8x1_fr = fmc_fr;

assign #(REFCLK_PERIOD/6) ref6x2_fr  = fmc_fr;
assign #(REFCLK_PERIOD/7) ref7x2_fr  = fmc7x2_fr;
assign #(REFCLK_PERIOD/8) ref8x2_fr  = fmc_fr;

reg fr;
always @ (mode or 
          shdn or
          ref6x1_fr or
          ref7x1_fr or
          ref8x1_fr or
          ref6x2_fr or
          ref7x2_fr or
          ref8x2_fr)
begin
  if (~shdn)
    fr   <= 1'b0;
  else
  begin
  case (mode)
  3'b000:  fr   <= ref8x2_fr;
  3'b001:  fr   <= ref7x2_fr;
  3'b010:  fr   <= ref6x2_fr;
  3'b011:  fr   <= 1'b0;
  3'b100:  fr   <= 1'b0;
  3'b101:  fr   <= ref7x1_fr;
  3'b110:  fr   <= ref6x1_fr;
  3'b111:  fr   <= ref8x1_fr;
  default: fr   <= 1'b0;
  endcase
  end
end





wire fr_u = fr;
wire dco_u = dco;

wire fr_d = fr;
wire dco_d = dco;

          
    alt_outbuf_diff dco_u_buf
    (
        .i                              (dco_u), 
        .o                              (dco_u_p),
        .obar                           (dco_u_n)
    );
    alt_outbuf_diff fr_u_buf
    (
        .i                              (fr_u), 
        .o                              (fr_u_p),
        .obar                           (fr_u_n)
    );                                                                       
    alt_outbuf_diff out0a_buf
    (
        .i                              (out0a), 
        .o                              (out0a_p),
        .obar                           (out0a_n)
    );
    alt_outbuf_diff out0b_buf
    (
        .i                              (out0b), 
        .o                              (out0b_p),
        .obar                           (out0b_n)
    );
    alt_outbuf_diff out1a_buf
    (
        .i                              (out1a), 
        .o                              (out1a_p),
        .obar                           (out1a_n)
    );
    alt_outbuf_diff out1b_buf
    (
        .i                              (out1b), 
        .o                              (out1b_p),
        .obar                           (out1b_n)
    );
    alt_outbuf_diff out2a_buf
    (
        .i                              (out2a), 
        .o                              (out2a_p),
        .obar                           (out2a_n)
    );
    alt_outbuf_diff out2b_buf
    (
        .i                              (out2b), 
        .o                              (out2b_p),
        .obar                           (out2b_n)
    );
    alt_outbuf_diff out3a_buf
    (
        .i                              (out3a), 
        .o                              (out3a_p),
        .obar                           (out3a_n)
    );
    alt_outbuf_diff out3b_buf
    (
        .i                              (out3b), 
        .o                              (out3b_p),
        .obar                           (out3b_n)
    );


    
    alt_outbuf_diff dco_d_buf
    (
        .i                              (dco_d), 
        .o                              (dco_d_p),
        .obar                           (dco_d_n)
    );
    alt_outbuf_diff fr_d_buf
    (
        .i                              (fr_d), 
        .o                              (fr_d_p),
        .obar                           (fr_d_n)
    );                                                                       
    alt_outbuf_diff out4a_buf
    (
        .i                              (out4a), 
        .o                              (out4a_p),
        .obar                           (out4a_n)
    );
    alt_outbuf_diff out4b_buf
    (
        .i                              (out4b), 
        .o                              (out4b_p),
        .obar                           (out4b_n)
    );
    alt_outbuf_diff out5a_buf
    (
        .i                              (out5a), 
        .o                              (out5a_p),
        .obar                           (out5a_n)
    );
    alt_outbuf_diff out5b_buf
    (
        .i                              (out5b), 
        .o                              (out5b_p),
        .obar                           (out5b_n)
    );
    alt_outbuf_diff out6a_buf
    (
        .i                              (out6a), 
        .o                              (out6a_p),
        .obar                           (out6a_n)
    );
    alt_outbuf_diff out6b_buf
    (
        .i                              (out6b), 
        .o                              (out6b_p),
        .obar                           (out6b_n)
    );
    alt_outbuf_diff out7a_buf
    (
        .i                              (out7a), 
        .o                              (out7a_p),
        .obar                           (out7a_n)
    );
    alt_outbuf_diff out7b_buf
    (
        .i                              (out7b), 
        .o                              (out7b_p),
        .obar                           (out7b_n)
    );
 
endmodule
