module serializer_sim #
(
      parameter SERIAL_BITS              =   16 // simulation setting for MGT smartmodel
)
(
pda_in,
sda_out,
clk1x,
clkxx,
rst
);
input [SERIAL_BITS - 1:0] pda_in;
output sda_out;
input  clk1x;
input  clkxx;
input  rst;

reg [SERIAL_BITS - 1:0] pda_in_reg;


always @ (posedge clk1x)
begin
  if (~rst)
    pda_in_reg <= 16'b0;
  else
    pda_in_reg <= pda_in;   
end

always @ (posedge clkxx or negedge clkxx)
  pda_in_reg <= pda_in_reg << 1;

reg sda_out;

always @ (posedge clkxx or negedge clkxx)
  sda_out <= pda_in_reg[SERIAL_BITS -1];

endmodule  
