/******************************************************************************
* Copyright (c) 2011, Linear Technology, Corp.                                *
* Linear Tech Proprietary and Confidential                                    *
*                                                                             *
* Title:                                                                      *
* Author:          Gary Yu                                                    *
* Create Date:     10:08:58 09/09/2011                                        *
* Design Name:                                                                *
* Module Name:                                                                *
* Project Name:                                                               *
* Target Devices:                                                             *
* Tool versions:                                                              *
* Description:                                                                *
*                                                                             *
* Dependencies:                                                               *
*                                                                             *
* Revision 1.0     10:08:58 09/09/2011 Gary Yu                                *
* File Created                                                                *
*                                                                             *
* Additional Comments:                                                        *
*                                                                             *
******************************************************************************/

`timescale 1ns / 1ps

`define P_N_SDR_8x2
//`define FPGA_POSTPAR_SIM
module EXAMPLE_TB;


//*************************Parameter Declarations******************************    
    //parameter   REFCLK_PERIOD   =   8.000000;//125M
    parameter   REFCLK_PERIOD   =   9.000000;
    //parameter   REFCLK_PERIOD   =   9.0050000;
      
    parameter   SYSCLK_PERIOD        =   20.000000;//50M
//************************** Register Declarations ****************************        
reg             sys_clk;


reg             PWR_RESET;



//********************************Wire Declarations**********************************

  // ----------------------------------------------------
  // CLK_CTRL
  // ----------------------------------------------------
wire       refclk_p_r;
wire       refclk_n_r;

wire       sysclk_r;


  // ----------------------------------------------------
  // LCD interface 
  // ----------------------------------------------------

wire       lcd_d_cn;   //LCD Data/Command select
wire       lcd_wen;    //LCD Read Write select
wire       lcd_csn;    //LCD Chip select
wire [7:0] lcd_data;   //LCD Data bus

 `ifdef FPGA_POSTPAR_SIM
assign #1  lcd_data = ((EXAMPLE_TB.top_fpga.\lcdrw_ctrl|fl_cnt == 2'b11) && (lcd_wen)) ? 8'h7f : 8'bz;//LCD panel is always ready
 `else 
assign #1  lcd_data = ((EXAMPLE_TB.top_fpga.lcdrw_ctrl.fl_cnt == 2'b11) && (lcd_wen)) ? 8'h7f : 8'bz;//LCD panel is always ready
 `endif
 
pullup(lcd_data[7]);
//*********************************Main Body of Code**********************************


    //---------------------Jumper Setting & Push Botton------------------------
        
    
    //-------------------------------- Resets ---------------------------------
    
    initial
    begin
        PWR_RESET = 1'b1;
        #(100 * REFCLK_PERIOD) PWR_RESET = 1'b0;
    end

    
    
    //---------------------- Generate Reference Clock -------------------------
    initial 
    begin
        sys_clk = 1'b1;
    end

      
    always  
      #(SYSCLK_PERIOD/2) sys_clk = !sys_clk;
   
    sqclkd sqclkd_sys(sys_clk, 1'b1, sysclk_r);
    
    reg flag0, flag1, flag2, flag3;

    //------------------------------ Operation --------------------------------
    initial
    begin
    flag0 = 1;
    flag1 = 0;
    flag2 = 0;
                
    #(6 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[29] = 8'h0;
    flag0 = 0;
        
    #(26 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[2] = 8'h01;
    flag1 = 1;
    #(10 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[2] = 8'h0;
    flag1 = 0;

    #(22 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h01;
    flag2 = 1;
    #(10 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h0;
    flag2 = 0;
      
    #(54 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h01;
    flag2 = 1;
    #(10 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h0;
    flag2 = 0;
    
    
    
    
    
    #(18 * 200 * SYSCLK_PERIOD); 
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[29] = 8'h01;
    flag0 = 1;
    #(10 * 200 * SYSCLK_PERIOD); 
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[29] = 8'h0;
    flag0 = 0;

    #(26 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[2] = 8'h01;
    flag1 = 1;
    #(10 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[2] = 8'h0;
    flag1 = 0;

    #(22 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h01;
    flag2 = 1;
    #(10 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h0;
    flag2 = 0;
      
    #(54 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h01;
    flag2 = 1;
    #(10 * 200 * SYSCLK_PERIOD);
    EXAMPLE_TB.top_fpga.altcnfig.altcnfigram1.altsyncram_component.mem_data[3] = 8'h0;
    flag2 = 0;

    end
     


    

     
logic9011 #
(
      .REFCLK_PERIOD              (REFCLK_PERIOD)
)
logic9011
(

.dco_u_p(dco_u_p),
.dco_u_n(dco_u_n),

.fr_u_p(fr_u_p),
.fr_u_n(fr_u_n),

.out0a_p(out0a_p),
.out0a_n(out0a_n),

.out0b_p(out0b_p),
.out0b_n(out0b_n),

.out1a_p(out1a_p),
.out1a_n(out1a_n),

.out1b_p(out1b_p),
.out1b_n(out1b_n),

.out2a_p(out2a_p),
.out2a_n(out2a_n),

.out2b_p(out2b_p),
.out2b_n(out2b_n),

.out3a_p(out3a_p),
.out3a_n(out3a_n),

.out3b_p(out3b_p),
.out3b_n(out3b_n),

.dco_d_p(dco_d_p),
.dco_d_n(dco_d_n),

.fr_d_p(fr_d_p),
.fr_d_n(fr_d_n),

.out4a_p(out4a_p),
.out4a_n(out4a_n),

.out4b_p(out4b_p),
.out4b_n(out4b_n),

.out5a_p(out5a_p),
.out5a_n(out5a_n),

.out5b_p(out5b_p),
.out5b_n(out5b_n),

.out6a_p(out6a_p),
.out6a_n(out6a_n),

.out6b_p(out6b_p),
.out6b_n(out6b_n),

.out7a_p(out7a_p),
.out7a_n(out7a_n),

.out7b_p(out7b_p),
.out7b_n(out7b_n),

.shdn(~PWR_RESET),
.mode(3'b000)
  );
               

    top_FPGA top_fpga
    (
  // ----------------------------------------------------
  // System Clock 
  // ----------------------------------------------------
        .SYSCLK(sysclk_r),
        
  // ----------------------------------------------------
  // LCD interface 
  // ----------------------------------------------------
        .lcd_d_cn(lcd_d_cn),
        .lcd_wen(lcd_wen),
        .lcd_csn(lcd_csn),
        .lcd_data(lcd_data),
    
  // ----------------------------------------------------
  // General Control and Jumper 
  // ----------------------------------------------------
  // ----------------------------------------------------
  // 9011 interface
  // ----------------------------------------------------
        
        
        .dco_u_n(dco_u_p),//gyu Reverse pn
        .dco_u_p(dco_u_n),

        .fr_u_n(fr_u_p),//gyu Reverse pn
        .fr_u_p(fr_u_n),

        .out0a_n(out0a_p),//gyu Reverse pn
        .out0a_p(out0a_n),
        .out0b_n(out0b_p),//gyu Reverse pn 
        .out0b_p(out0b_n), 
        .out1a_n(out1a_p),//gyu Reverse pn 
        .out1a_p(out1a_n), 
        .out1b_n(out1b_p),//gyu Reverse pn 
        .out1b_p(out1b_n), 
        .out2a_n(out2a_p),//gyu Reverse pn
        .out2a_p(out2a_n),
        .out2b_n(out2b_p),//gyu Reverse pn
        .out2b_p(out2b_n),
        .out3a_n(out3a_p),//gyu Reverse pn 
        .out3a_p(out3a_n), 
        .out3b_n(out3b_p),//gyu Reverse pn
        .out3b_p(out3b_n),


        .dco_d_n(dco_d_p),//gyu Reverse pn
        .dco_d_p(dco_d_n),

        .fr_d_n(fr_d_p),//gyu Reverse pn
        .fr_d_p(fr_d_n),

        .out4a_n(out4a_p),//gyu Reverse pn
        .out4a_p(out4a_n),
        .out4b_n(out4b_p),//gyu Reverse pn
        .out4b_p(out4b_n),
        .out5a_n(out5a_p),//gyu Reverse pn
        .out5a_p(out5a_n),
        .out5b_n(out5b_p),//gyu Reverse pn
        .out5b_p(out5b_n),
        .out6a_n(out6a_p),//gyu Reverse pn 
        .out6a_p(out6a_n), 
        .out6b_n(out6b_p),//gyu Reverse pn 
        .out6b_p(out6b_n), 
        .out7a_n(out7a_p),//gyu Reverse pn
        .out7a_p(out7a_n),
        .out7b_n(out7b_p),//gyu Reverse pn
        .out7b_p(out7b_n)//,  
      
  // ----------------------------------------------------
  // Indication
  // ----------------------------------------------------
                                    
    );

    
 initial
 begin
 `ifdef FPGA_POSTPAR_SIM
                $sdf_annotate("../imp/top_FPGA_v.sdo",EXAMPLE_TB.top_fpga, ,"sdfbase.log","MAXIMUM");
                $fsdbDumpfile ("pstache_post.fsdb");                  
 `else                
                $fsdbDumpfile ("pstache_behav.fsdb");         
 `endif                   
                $fsdbDumpvars (0,EXAMPLE_TB);
                $fsdbDumpon;
                #1200000;
                $finish;

 end
  
endmodule

