/******************************************************************************
* Copyright (c) 2011, Linear Technology, Corp.                                *
* Linear Tech Proprietary and Confidential                                    *
*                                                                             *
* Title:                                                                      *
* Author:          Gary Yu                                                    *
* Create Date:     10:08:58 09/09/2011                                        *
* Design Name:                                                                *
* Module Name:                                                                *
* Project Name:                                                               *
* Target Devices:                                                             *
* Tool versions:                                                              *
* Description:                                                                *
*                                                                             *
* Dependencies:                                                               *
*                                                                             *
* Revision 1.0     10:08:58 09/09/2011 Gary Yu                                *
* File Created                                                                *
*                                                                             *
* Additional Comments:                                                        *
*                                                                             *
******************************************************************************/

`timescale 1ns / 1ps

module altbram_addr
(
addr_trigger, 
addr,

capture_done,
capture_data,

BUFFER_ADDR_CNT);

parameter ADDBITS = 13;

input  addr_trigger; 

input        capture_data;

output [ADDBITS - 1:0] addr;
output        capture_done;

input [ADDBITS - 4:0] BUFFER_ADDR_CNT;

reg [ADDBITS - 1:0] addr;
reg capture_done;
     
always @ (posedge addr_trigger or negedge capture_data)
  if(~capture_data)
  begin
    addr             <= #1 0;
    capture_done     <= #1 1'b0;
  end
  else
      if(addr == {BUFFER_ADDR_CNT, 3'b110})
      begin
        capture_done <= #1 1'b1;
        addr         <= #1 addr + 1;
      end
      else if ((addr == {BUFFER_ADDR_CNT, 3'b111}) && capture_done)
      begin
        addr         <= #1 addr;
        capture_done <= #1 1'b0;
      end  
      else
        addr         <= #1 addr + 1;
     
endmodule
